include \masm32\include\masm32rt.inc

create_draw     proto :dword, :dword
print_draw      proto :dword
sort_draw       proto
compare_draw    proto
; -------------------------------------------------------------------------
.const
; -------------------------------------------------------------------------
range     equ 45
nbr       equ  6
CRLF      equ 13,10,0
maxdd     equ 0ffffffffh
; -------------------------------------------------------------------------
.data?
; -------------------------------------------------------------------------

; -------------------------------------------------------------------------
.data
; -------------------------------------------------------------------------
draw        dd  nbr+1 dup (0)        ; Array of generated draw
SechserMi   dd  21,26,28,36,39,40,16 ; Array that holds some "real-world-draw"
                                     ; plus "additional number"
; I plan for later to read all "real_world_draws" from a file and let the
; program tell me if the generated draw was a win

clbuf       db  200 dup (?)

cnt         dd  0                 ; Number of draws to generate
arr         dd  range dup (0)     ; Occurence of every number for _active draw_
arr1        dd  range dup (0)     ; Occurence of every number for _all draws_ generated
richtige    dd  nbr+1 dup (0)     ; Array of correct numbers, e.g.
                                  ; if x numbers of draw correct richtige(x) is incremented
tick1       dd  0                 ; Time-Measurement and "seed" for nrandom
; -------------------------------------------------------------------------

.code
start:

invoke GetTickCount
mov tick1, eax
call Main
invoke GetTickCount
sub eax, tick1
mov tick1, eax

invoke Beep, 110, 125
print chr$(CRLF)
print str$(tick1), "ms",13,10
inkey
exit
; -------------------------------------------------------------------------

Main proc
    invoke GetCL, 1, ADDR clbuf     ; Get number of draws to generate from
    .if eax == 1                    ; the commandline, if n/a
        invoke atodw, ADDR clbuf    ; do 2^32-1 (maxdd) draws
        mov cnt, eax
    .else
        mov cnt, maxdd
    .endif
    
    invoke ClearScreen
    invoke GetTickCount ; Zufallsgenerator mit feed the random-number-generator
    invoke nseed, eax   ; aktuellen Ticks fttern with the tickcount
    print "Mi Sechser....: "
    invoke print_draw, ADDR SechserMi
    print chr$(CRLF)
    .repeat
        invoke create_draw, range, nbr
        invoke sort_draw
        invoke compare_draw
        inc [richtige+eax*4]
        ;print str$(cnt)
        ;print chr$(9)
        ;invoke print_draw, ADDR draw
        dec cnt
    .until cnt == 0
    
    print chr$(CRLF)
    print "6er "
    print str$([richtige+6*4]),CRLF
    print "5er "
    print str$([richtige+5*4]),CRLF
    print "4er "
    print str$([richtige+4*4]),CRLF
    print "3er "
    print str$([richtige+3*4]),CRLF
    print "2er "
    print str$([richtige+2*4]),CRLF
    print "1er "
    print str$([richtige+1*4]),CRLF
    print "nix "
    print str$([richtige]),CRLF
    
    xor ebx, ebx
    .repeat
        print "Zahl: "
        .if ebx < 9
            print " "
        .endif
        mov eax, ebx
        inc eax
        print str$(eax)
        print " gekommen "
        print str$([arr1+ebx*4])
        print chr$(CRLF)
        inc ebx
    .until ebx == range
    ret
Main endp
; -------------------------------------------------------------------------

create_draw proc Max:DWORD, nbr1:DWORD

    xor ebx, ebx
    .repeat
        mov [arr+ebx*4], 0
        inc ebx
    .until ebx == range

    xor ebx, ebx
    .repeat
@@:     invoke nrandom, Max         ; eax = Zufallszahl
        inc eax                     ; +1 (nrandom erzeugt 0..Max-1)

        mov [draw+ebx*4], eax 
        dec eax                     ; arr geht von 0..44, eax 1..45
        inc [arr+eax*4]             ; Merken, wie oft die Zahl gekommen ist
        .if [arr+eax*4] > 1         ; Wenn Zahl bereits gekommen
            dec [arr+eax*4]
            jmp @B
        .endif
        inc [arr1+eax*4]            ; wie oft die Zahl insgesamt gekommen ist
        ;dec Max
        inc ebx
    .until ebx == nbr1
ZZ:
    invoke nrandom, range         ; Zusatzzahl erzeugen
    .if [arr+eax*4] == 1            ; Wenn Zahl bereits gezogen
        jmp ZZ                      ; andere Zahl erzeugen
    .endif
    inc eax                         ; Zahl anpassen
    mov [draw+ebx*4], eax        ; speichern in draw(6)
    ret
create_draw endp
; -------------------------------------------------------------------------

print_draw proc Zi:dword
    xor ebx, ebx                ; Index initialisieren
    mov esi, Zi                 ; esi adressiert draw
    .repeat
        ;mov eax, [esi+ebx*4]    ; eax = draw(Index)
        ;push eax
        .if dword ptr [esi+ebx*4] < 10
            print " "
        .endif
        print str$([esi+ebx*4])
        inc ebx
        .if ebx < nbr
            print ", "
        .endif
    .until ebx == nbr        ; ebx zeigt auf letzte Zahl (Zusatzzahl)
    print chr$(9)
    print str$([esi+ebx*4])     ; Drucke ZZ
    print chr$(CRLF)
    ret
print_draw endp
; -------------------------------------------------------------------------

sort_draw proc
    xor ebx, ebx    ; Index Array
    xor eax, eax    ; Index draw
    .repeat
        .if [arr+ebx*4] != 0
            inc ebx        
            mov [draw+eax*4], ebx
            dec ebx
            inc eax
        .endif
        inc ebx
    .until ebx == range
    ret    
sort_draw endp
; -------------------------------------------------------------------------

compare_draw proc 

    xor eax, eax    ; Zhler richtige Zahlen (Rckgabewert)
    xor ebx, ebx    ; Index auf generierte draw
    xor ecx, ecx    ; Index auf tatschliche draw
    .repeat
        .while ecx < nbr
            mov edx, [SechserMi+ecx*4]  ; edx = Sechser(0..5)
            .if edx == [draw+ebx*4]  ; if Sechser(0..5) = draw(0)
                inc eax
                .break                  ; Zahlen gleich->raus aus .while
            .endif
            inc ecx
        .endw
        inc ebx
        xor ecx, ecx
    .until ebx == nbr
    ret
compare_draw endp

end start
